Redmine - Feature #23310
Improved "jump to project” drop-down
2016-07-12 23:54 - Jean-Philippe Lang

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 3.4.0

Resolution: Fixed

Description

I'd like to replace the "jump to project..." select with a more elaborate drop-down under the "Projects” link in the header. Here are
some mockups for the standard and the mobile views.
The drop-down would display user's projects by default and provide an ajax based search field for finding other projects.

I'm setting it for 3.4.0, please let me know what you think about this change.
Related issues:
Related to Redmine - Patch #4218: Javascript Project Selection Closed 2009-11-14
Related to Redmine - Patch #19370: Parent projects in project jump dropdown New
Related to Redmine - Feature #7935: Add "View all issues" link to top_menu + ... Closed 2011-03-21
Related to Redmine - Feature #14006: A shortcut to view all issues of all pro... Closed
Related to Redmine - Defect #5522: "search" form should have "all projects” a... Closed 2010-05-13
Related to Redmine - Feature #19299: Project Quick Jump Dropdown - Sorting/Or... Closed
Related to Redmine - Patch #24833: Always show "Jump to project" drop-down Closed
Related to Redmine - Feature #7751: Filter projects dropdown menu Closed 2011-03-02
Has duplicate Redmine - Feature #5860: quick jump project combo improvement Closed 2010-07-09
Has duplicate Redmine - Feature #10737: Make the quick search a combo box Closed

Associated revisions

Revision 15994 - 2016-11-26 09:16 - Jean-Philippe Lang

Replaces project jump select with custom dropdown (#23310).

Revision 16172 - 2017-01-10 19:33 - Jean-Philippe Lang
Adds a link to all projects in the jump drop down (#23310).

Revision 16506 - 2017-04-06 19:13 - Jean-Philippe Lang

Set autocomplete to off on project quick search (#23310).

Patch by Marius BALTEANU.

Revision 16687 - 2017-06-25 10:51 - Jean-Philippe Lang
Fix project jump box text when creating/editing a project (#23310).

Revision 16688 - 2017-06-25 10:53 - Jean-Philippe Lang
Merged r16687 (#23310).

History

#1 - 2016-07-13 09:12 - Marius BALTEANU
- File parent_task.png added

IMHO, it looks very good and solves a big current Ul/UX issue: the impossibility to search after the project name (now we use the search from the
browser, but we need to navigate first to projects page). Also, it can be improved in the future to include something like: recent projects (e.g: the last 3
projects opened by user) or favorite projects.

A little bit off topic, do you have in plan to use the JS library Select2 to implement this? I'm asking because in our environment we use that library to
make some improvements in parent task autocomplete from the issue page (parent_task.png) and we can contribute with the changes if the library
will be part of the Redmine core.

#2 - 2016-07-13 11:39 - Anonymous

+1
This sounds like a great improvement!

#3 - 2016-07-13 15:54 - budo kaiman
For mobile, where exactly does that dropdown come from? Is it from clicking on the "Redmine" project name? | definitely think the new menu is an

improvement, the placing just seems a bit odd to me (on both views).

#4 - 2016-07-13 19:57 - Jake Kemme
- File selectplugin.PNG added

We currently use the Improved Searchbox Plugin and would prefer to not move the quicksearch to a dropdown menu in core redmine.

#5 - 2016-07-13 20:05 - Robert Korulczyk

+1 for that. This will solve another annoying issue - finally you will be able to easily open different project in new tab by using middle-click.

#6 - 2016-07-16 21:13 - Sebastian Paluch

Although, I like the functionality (Ajax), I'm not convinced that moving this drop down is good idea.

Users are used to current drop down, this is most important, mostly used navigation way. | can already hear all the questions from dozens of users...
There is no other drop down menus like that, so, proposed solution seems to be totally new approach, not aligned with current style/navigation/etc.
Please also take a look on #19370.

#7 - 2016-07-18 05:48 - Go MAEDA
- Related to Patch #4218: Javascript Project Selection added

#8 - 2016-07-19 18:05 - Jake Kemme
- File mobile-menu.png added
- File site-menu.png added

- File minimal-menu.png added

Here is an alternate proposal which matches other sites like gitlab, based on jquery-ui/ fontawesome with the typical dropdown chevron
https://select2.github.io/examples.html
www.redmine.org/plugins/redmine_improved_searchbox
https://www.redmine.org/issues/19370
Or, stick with a minimal change approach to avoid user confusion:

TimeClock

Go to a project

@ N Advanced General Aviation Transpaort
Human-centered computing (NASA)
Astrobiology for Exploring Plane...
Add filter Deep Space Habitat
HL-20 Personnel Launch System

Heliophysics Science Division

High Resolution Microwave Study

RN N ) RPN o PO —

Also available in: g} Atom | CSV | PDF

#9 - 2016-08-10 03:59 - Toshi MARUYAMA
- Related to Patch #19370: Parent projects in project jump dropdown added

#10 - 2016-09-16 11:36 - Jan from Planio www.plan.io
We had implemented this functionality for a client as a plugin based on the popular Select2 for jQuery.

We could transform this into a core patch and propose it here, if that is desired. But it probably would not make sense if there's existing code for this
yet.

Jean-Philippe, are your screenshots made with Photoshop or do you have working code yet? Would you like us to propose an implementation based
on Select2?

#11 - 2016-10-08 12:25 - Jean-Philippe Lang
https://select2.github.io/

| have some working code for this but it does not rely on Select2. Select2 has a huge footprint and I'd prefer not to use it.
#12 - 2016-10-11 17:24 - Jan from Planio www.plan.io
Jean-Philippe Lang wrote:

| have some working code for this but it does not rely on Select2. Select2 has a huge footprint and I'd prefer not to use it.

Okay, thanks for your feedback. Then, we'll happily wait for your implementation!

#13 - 2016-10-11 23:22 - Robert Schneider

May | suggest to think about a better project page (proposals are in many tickets, e.g. #3224) instead of implementing this project select? Since |
don't see the big advantage of it. Although it's not bad to have it | would prefer to have better search and order options on the project page, together
with some project information. There it could be also implemented with a "live" filtering (somehow).

One reason, why | don't like it that much, is that | need to open the dropdown with the mouse and then switch to the keyboard. And after that | will
probably use the mouse again. A single click on the Projects link and some scrolling could be in many situations faster.

Just my 2 cents. Maybe | don't see the advantage yet.

#14 - 2016-10-12 13:08 - budo kaiman

Robert Schneider wrote:

One reason, why | don't like it that much, is that | need to open the dropdown with the mouse and then switch to the keyboard. And after that |
will probably use the mouse again. A single click on the Projects link and some scrolling could be in many situations faster.

| don't think you'd need to switch to the keyboard with the drop-down. Once you open the drop-down, you should be able to just scroll through the list
(ie. exactly what you are proposing for the projects page, just without the extra page load).

#15 - 2016-12-16 09:07 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Fixed

The new "jump to project” drop-down that allow to search in all projects is committed.

#16 - 2016-12-19 18:36 - Kush Suryavanshi

For us, because we have more than 500 projects, this is really useful. Though, we would love to see #3224 with filter, order by, sort and export
capacity just like issues - as it will help us in reporting on projects. Thanks much for this enhancement in drop down.

#17 - 2016-12-23 11:21 - Go MAEDA

- Has duplicate Feature #5860: quick jump project combo improvement added

#18 - 2017-01-11 01:16 - Go MAEDA
- Related to Feature #7935: Add "View all issues" link to top_menu + home added

#19 - 2017-01-11 01:17 - Go MAEDA

- Related to Feature #14006: A shortcut to view all issues of all projects added

#20 - 2017-01-11 07:46 - Go MAEDA
- File all-projects-link.png added

| really liked the "All projects” link implemented in r16172. The operability of seeing cross-project information is greatly improved. Thanks,
Jean-Phillipe.

2025-07-13 5/8


https://www.redmine.org/issues/3224
https://www.redmine.org/issues/3224
https://www.redmine.org/projects/redmine/repository/svn/revisions/16172

all-projects-link.png
It covers feature request #14006 and #5860. | closed them.

#21 - 2017-01-15 03:35 - Go MAEDA
- Related to Defect #5522: "search" form should have "all projects” and "my projects" added

#22 - 2017-01-15 03:44 - Go MAEDA

- Related to Feature #19299: Project Quick Jump Dropdown - Sorting/Ordering or Dynamic Searching of Current User's Projects added
https://www.redmine.org/issues/14006
https://www.redmine.org/issues/5860

#23 - 2017-01-15 13:08 - Jean-Philippe Lang
- Related to Patch #24833: Always show "Jump to project"” drop-down added

#24 - 2017-04-05 18:12 - Marius BALTEANU
- File autocomplete-on.png added

- File autocomplete-off.png added

- File autocomplete-off.diff added

I'm proposing to set the autocomplete off for the search input in order to avoid the cases where the autocomplete suggestions (from the browser
history) overlaps the results returned in the dropdown. For example, I've the following issue on my chrome browser:

autocomplete-on.png
Setting the autocomplete attribute to off (patch attached):
autocomplete-off.png
| didn't open a new issue because the change is very small. If it is necessary, please let me know.

#25 - 2017-04-05 18:15 - Toshi MARUYAMA

- Status changed from Closed to Reopened

#26 - 2017-04-05 18:20 - Marius BALTEANU
- File autocomplete-off.diff added

Sorry, I've a mistake in my patch. Attaching the correct one.

#27 - 2017-04-06 19:13 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Patch committed, thanks.

#28 - 2017-06-21 15:03 - Takeshi Nakamura

On new project creation screen, "Jump to project..." is not shown in the drop-down.
When accessing /projects/new, @project.try(:name) returns not nil but empty.
source:/trunk/app/helpers/application_helper.ro@16680#L380

#29 - 2017-06-21 16:36 - Go MAEDA

- Status changed from Closed to Reopened
Takeshi Nakamura wrote:
On new project creation screen, "Jump to project..." is not shown in the drop-down.

When accessing /projects/new, @project.try(:name) returns not nil but empty.
source:/trunk/app/helpers/application_helper.rb@16680#L.380

Thank you for catching it. Here is a patch to fix the problem.

Index: app/helpers/application_helper.rb

-—— app/helpers/application_helper.rb (revision 16680)
+++ app/helpers/application_helper.rb (working copy)
@@ -377,7 +377,8 @@
# Renders the project quick-jump box
def render_project_jump_box
projects = projects_for_ jump_box (User.current)

text = @project.try(:name) || 1l(:label_jump_to_a_project)

+ text = (@project.try(:name)

+ text = 1 (:label_jump_to_a_project) if text.blank?
url = autocomplete_projects_path(:format => 'Jjs', :jump => current_menu_item)
trigger = content_tag('span', text, :class => 'drdn-trigger')

#30 - 2017-06-21 16:53 - Holger Just
Another option could be to use Object#presence as follows:
https://www.redmine.org/projects/redmine/repository/svn/revisions/16680/entry/trunk/app/helpers/application_helper.rb#L380
https://www.redmine.org/projects/redmine/repository/svn/revisions/16680/entry/trunk/app/helpers/application_helper.rb#L380
http://api.rubyonrails.org/classes/Object.html#method-i-presence

text = @project.try(:name) .presence

#31 - 2017-06-25 10:55 - Jean-Philippe Lang

- Status changed from Reopened to Closed

1(:label_jump_to_a_project)

Fixed in r16688. #project_was is used to fix the text when editing a project as well (eg. edit a project, clear the ites name and submit).

Please open new tickets for defects on this feature from now on.

#32 - 2020-06-06 07:01 - Go MAEDA
- Related to Feature #7751: Filter projects dropdown menu added

#33 - 2021-06-06 10:16 - Go MAEDA

- Has duplicate Feature #10737: Make the quick search a combo box added
